var mongoose = require('mongoose'),
    config = require('../config/conftool.js').getConf(),
    Hook = mongoose.model('Hook'),
    handler = require('../libs/event_handler.js').getHandler();

exports.doHook = function(req, res, next){
  if (!req.body || !req.method === 'POST') return next();
  var payload;
  payload = typeof req.body.payload === 'object' ? req.body.payload : JSON.parse(req.body.payload);
  req.payload = payload;
  console.log(payload);
  var repo = payload.repository.owner.name + '/' + payload.repository.name;
  var commit = payload.head_commit.message;
  console.log(repo, commit);
  Hook.findOne({lookupId: 'github' + '-' + payload.repository.owner.name},
    function(err, obj){
      if(err) return next(err);
      else{
        if(obj){
          console.log('found matching hook account for github ');
          console.log(obj);
          var evt = { user: obj.user, _id: obj._id, 
                      provider: 'github', data: { repo: repo, commit: commit }};
          handler.emit('event::new', evt);
          }
          else{
          console.log('no hook found');
          }
      }
    }
  );
  res.send({ result: 'ok'}, 200);
}
