var restify = require('restify');
var config = require("./config/conftool.js").getConf();

var fs = require('fs');
var server = restify.createServer({
  name: 'grid-react-hook',
  version: '0.0.1'
});
var mongoose = require('mongoose')
  , Schema = mongoose.Schema
  mongoose.connect(config.db);

var models_path = __dirname + '/models'
  , model_files = fs.readdirSync(models_path);
model_files.forEach(function(file) {
  require(models_path+'/'+file)
});


require('./libs/event_queue_agent.js').boot(config.memory);

server.use(restify.acceptParser(server.acceptable));
server.use(restify.queryParser());
server.use(restify.bodyParser({mapParams: false}));

var travis = require('./controllers/travis');
var github = require('./controllers/github');
var callerId = require('./controllers/callerid');

server.post('/travisci', travis.doHook);
server.post('/github', github.doHook);
server.post('/callerId', callerId.doHook);

server.listen(config.port, function(){
  console.log('Grid React Hook loaded on port ' + config.port);
});
